{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.CodeGenerator
       (
         CodeGenerator,
         CodeGeneratorClass(..),
         codeGenerator__0,
         codeGenerator__1,
         codeGenerator_addInclude__0,
         codeGenerator_addInclude__1,
         codeGenerator_addInclude__2,
         codeGenerator_add__0,
         codeGenerator_add__1,
         codeGenerator_compile__0,
         codeGenerator_compile__1,
         codeGenerator_generate__0,
         codeGenerator_generate__1,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__CONSTRUCTOR__0" c_casadi__CodeGenerator__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> IO (Ptr CodeGenerator')
casadi__CodeGenerator__CONSTRUCTOR__0
  :: IO CodeGenerator
casadi__CodeGenerator__CONSTRUCTOR__0  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__CONSTRUCTOR__0 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator__0 :: IO CodeGenerator
codeGenerator__0 = casadi__CodeGenerator__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__CONSTRUCTOR__1" c_casadi__CodeGenerator__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr CodeGenerator')
casadi__CodeGenerator__CONSTRUCTOR__1
  :: M.Map String GenericType -> IO CodeGenerator
casadi__CodeGenerator__CONSTRUCTOR__1 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__CONSTRUCTOR__1 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator__1 :: M.Map String GenericType -> IO CodeGenerator
codeGenerator__1 = casadi__CodeGenerator__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__add__0" c_casadi__CodeGenerator__add__0
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr Function' -> Ptr StdString -> IO ()
casadi__CodeGenerator__add__0
  :: CodeGenerator -> Function -> String -> IO ()
casadi__CodeGenerator__add__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__add__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_add__0 :: CodeGeneratorClass a => a -> Function -> String -> IO ()
codeGenerator_add__0 x = casadi__CodeGenerator__add__0 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__add__1" c_casadi__CodeGenerator__add__1
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr Function' -> IO ()
casadi__CodeGenerator__add__1
  :: CodeGenerator -> Function -> IO ()
casadi__CodeGenerator__add__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__add__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_add__1 :: CodeGeneratorClass a => a -> Function -> IO ()
codeGenerator_add__1 x = casadi__CodeGenerator__add__1 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__addInclude__0" c_casadi__CodeGenerator__addInclude__0
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr StdString -> IO ()
casadi__CodeGenerator__addInclude__0
  :: CodeGenerator -> String -> IO ()
casadi__CodeGenerator__addInclude__0 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__addInclude__0 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_addInclude__0 :: CodeGeneratorClass a => a -> String -> IO ()
codeGenerator_addInclude__0 x = casadi__CodeGenerator__addInclude__0 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__addInclude__1" c_casadi__CodeGenerator__addInclude__1
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr StdString -> CInt -> IO ()
casadi__CodeGenerator__addInclude__1
  :: CodeGenerator -> String -> Bool -> IO ()
casadi__CodeGenerator__addInclude__1 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__addInclude__1 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_addInclude__1 :: CodeGeneratorClass a => a -> String -> Bool -> IO ()
codeGenerator_addInclude__1 x = casadi__CodeGenerator__addInclude__1 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__addInclude__2" c_casadi__CodeGenerator__addInclude__2
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr StdString -> CInt -> Ptr StdString -> IO ()
casadi__CodeGenerator__addInclude__2
  :: CodeGenerator -> String -> Bool -> String -> IO ()
casadi__CodeGenerator__addInclude__2 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__addInclude__2 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_addInclude__2 :: CodeGeneratorClass a => a -> String -> Bool -> String -> IO ()
codeGenerator_addInclude__2 x = casadi__CodeGenerator__addInclude__2 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__compile__0" c_casadi__CodeGenerator__compile__0
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr StdString -> IO (Ptr StdString)
casadi__CodeGenerator__compile__0
  :: CodeGenerator -> String -> IO String
casadi__CodeGenerator__compile__0 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__compile__0 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_compile__0 :: CodeGeneratorClass a => a -> String -> IO String
codeGenerator_compile__0 x = casadi__CodeGenerator__compile__0 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__compile__1" c_casadi__CodeGenerator__compile__1
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr StdString -> Ptr StdString -> IO (Ptr StdString)
casadi__CodeGenerator__compile__1
  :: CodeGenerator -> String -> String -> IO String
casadi__CodeGenerator__compile__1 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__compile__1 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_compile__1 :: CodeGeneratorClass a => a -> String -> String -> IO String
codeGenerator_compile__1 x = casadi__CodeGenerator__compile__1 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__generate__0" c_casadi__CodeGenerator__generate__0
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> IO (Ptr StdString)
casadi__CodeGenerator__generate__0
  :: CodeGenerator -> IO String
casadi__CodeGenerator__generate__0 x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__generate__0 errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_generate__0 :: CodeGeneratorClass a => a -> IO String
codeGenerator_generate__0 x = casadi__CodeGenerator__generate__0 (castCodeGenerator x)


-- direct wrapper
foreign import ccall unsafe "casadi__CodeGenerator__generate__1" c_casadi__CodeGenerator__generate__1
  :: Ptr (Ptr StdString) -> Ptr CodeGenerator' -> Ptr StdString -> IO ()
casadi__CodeGenerator__generate__1
  :: CodeGenerator -> String -> IO ()
casadi__CodeGenerator__generate__1 x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__CodeGenerator__generate__1 errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
codeGenerator_generate__1 :: CodeGeneratorClass a => a -> String -> IO ()
codeGenerator_generate__1 x = casadi__CodeGenerator__generate__1 (castCodeGenerator x)

