{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.IterationCallback
       (
         IterationCallback,
         IterationCallbackClass(..),
         iterationCallback,
         iterationCallback_operator_call,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__IterationCallback__CONSTRUCTOR" c_casadi__IterationCallback__CONSTRUCTOR
  :: Ptr (Ptr StdString) -> IO (Ptr IterationCallback')
casadi__IterationCallback__CONSTRUCTOR
  :: IO IterationCallback
casadi__IterationCallback__CONSTRUCTOR  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IterationCallback__CONSTRUCTOR errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
iterationCallback :: IO IterationCallback
iterationCallback = casadi__IterationCallback__CONSTRUCTOR


-- direct wrapper
foreign import ccall unsafe "casadi__IterationCallback__operator_call" c_casadi__IterationCallback__operator_call
  :: Ptr (Ptr StdString) -> Ptr IterationCallback' -> Ptr Function' -> IO CInt
casadi__IterationCallback__operator_call
  :: IterationCallback -> Function -> IO Int
casadi__IterationCallback__operator_call x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__IterationCallback__operator_call errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
iterationCallback_operator_call :: IterationCallbackClass a => a -> Function -> IO Int
iterationCallback_operator_call x = casadi__IterationCallback__operator_call (castIterationCallback x)

