{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.LrDpleSolver
       (
         LrDpleSolver,
         LrDpleSolverClass(..),
         lrDpleSolver__0,
         lrDpleSolver__1,
         lrDpleSolver__2,
         lrDpleSolver_clone,
         lrDpleSolver_doc,
         lrDpleSolver_hasPlugin,
         lrDpleSolver_loadPlugin,
         lrDpleSolver_printStats,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__CONSTRUCTOR__0" c_casadi__LrDpleSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr (StdVec (Ptr Sparsity')))) -> IO (Ptr LrDpleSolver')
casadi__LrDpleSolver__CONSTRUCTOR__0
  :: String -> String -> M.Map String (Vector Sparsity) -> IO LrDpleSolver
casadi__LrDpleSolver__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver__0 :: String -> String -> M.Map String (Vector Sparsity) -> IO LrDpleSolver
lrDpleSolver__0 = casadi__LrDpleSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__CONSTRUCTOR__1" c_casadi__LrDpleSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr (StdVec (Ptr Sparsity')))) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr LrDpleSolver')
casadi__LrDpleSolver__CONSTRUCTOR__1
  :: String -> String -> M.Map String (Vector Sparsity) -> M.Map String GenericType -> IO LrDpleSolver
casadi__LrDpleSolver__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver__1 :: String -> String -> M.Map String (Vector Sparsity) -> M.Map String GenericType -> IO LrDpleSolver
lrDpleSolver__1 = casadi__LrDpleSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__CONSTRUCTOR__2" c_casadi__LrDpleSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr LrDpleSolver')
casadi__LrDpleSolver__CONSTRUCTOR__2
  :: IO LrDpleSolver
casadi__LrDpleSolver__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver__2 :: IO LrDpleSolver
lrDpleSolver__2 = casadi__LrDpleSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__clone" c_casadi__LrDpleSolver__clone
  :: Ptr (Ptr StdString) -> Ptr LrDpleSolver' -> IO (Ptr LrDpleSolver')
casadi__LrDpleSolver__clone
  :: LrDpleSolver -> IO LrDpleSolver
casadi__LrDpleSolver__clone x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__clone errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver_clone :: LrDpleSolverClass a => a -> IO LrDpleSolver
lrDpleSolver_clone x = casadi__LrDpleSolver__clone (castLrDpleSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__doc" c_casadi__LrDpleSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__LrDpleSolver__doc
  :: String -> IO String
casadi__LrDpleSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver_doc :: String -> IO String
lrDpleSolver_doc = casadi__LrDpleSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__hasPlugin" c_casadi__LrDpleSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__LrDpleSolver__hasPlugin
  :: String -> IO Bool
casadi__LrDpleSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver_hasPlugin :: String -> IO Bool
lrDpleSolver_hasPlugin = casadi__LrDpleSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__loadPlugin" c_casadi__LrDpleSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__LrDpleSolver__loadPlugin
  :: String -> IO ()
casadi__LrDpleSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver_loadPlugin :: String -> IO ()
lrDpleSolver_loadPlugin = casadi__LrDpleSolver__loadPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__LrDpleSolver__printStats" c_casadi__LrDpleSolver__printStats
  :: Ptr (Ptr StdString) -> Ptr LrDpleSolver' -> IO ()
casadi__LrDpleSolver__printStats
  :: LrDpleSolver -> IO ()
casadi__LrDpleSolver__printStats x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__LrDpleSolver__printStats errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
lrDpleSolver_printStats :: LrDpleSolverClass a => a -> IO ()
lrDpleSolver_printStats x = casadi__LrDpleSolver__printStats (castLrDpleSolver x)

