{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.QcqpSolver
       (
         QcqpSolver,
         QcqpSolverClass(..),
         qcqpSolver__0,
         qcqpSolver__1,
         qcqpSolver__2,
         qcqpSolver_doc,
         qcqpSolver_hasPlugin,
         qcqpSolver_loadPlugin,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__QcqpSolver__CONSTRUCTOR__0" c_casadi__QcqpSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> IO (Ptr QcqpSolver')
casadi__QcqpSolver__CONSTRUCTOR__0
  :: String -> String -> M.Map String Sparsity -> IO QcqpSolver
casadi__QcqpSolver__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QcqpSolver__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qcqpSolver__0 :: String -> String -> M.Map String Sparsity -> IO QcqpSolver
qcqpSolver__0 = casadi__QcqpSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__QcqpSolver__CONSTRUCTOR__1" c_casadi__QcqpSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr QcqpSolver')
casadi__QcqpSolver__CONSTRUCTOR__1
  :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO QcqpSolver
casadi__QcqpSolver__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QcqpSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qcqpSolver__1 :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO QcqpSolver
qcqpSolver__1 = casadi__QcqpSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__QcqpSolver__CONSTRUCTOR__2" c_casadi__QcqpSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr QcqpSolver')
casadi__QcqpSolver__CONSTRUCTOR__2
  :: IO QcqpSolver
casadi__QcqpSolver__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QcqpSolver__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qcqpSolver__2 :: IO QcqpSolver
qcqpSolver__2 = casadi__QcqpSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__QcqpSolver__doc" c_casadi__QcqpSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__QcqpSolver__doc
  :: String -> IO String
casadi__QcqpSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QcqpSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qcqpSolver_doc :: String -> IO String
qcqpSolver_doc = casadi__QcqpSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__QcqpSolver__hasPlugin" c_casadi__QcqpSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__QcqpSolver__hasPlugin
  :: String -> IO Bool
casadi__QcqpSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QcqpSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qcqpSolver_hasPlugin :: String -> IO Bool
qcqpSolver_hasPlugin = casadi__QcqpSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__QcqpSolver__loadPlugin" c_casadi__QcqpSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__QcqpSolver__loadPlugin
  :: String -> IO ()
casadi__QcqpSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QcqpSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qcqpSolver_loadPlugin :: String -> IO ()
qcqpSolver_loadPlugin = casadi__QcqpSolver__loadPlugin

