{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.QpSolver
       (
         QpSolver,
         QpSolverClass(..),
         qpSolver__0,
         qpSolver__1,
         qpSolver__2,
         qpSolver_doc,
         qpSolver_generateNativeCode,
         qpSolver_hasPlugin,
         qpSolver_loadPlugin,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__QpSolver__CONSTRUCTOR__0" c_casadi__QpSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> IO (Ptr QpSolver')
casadi__QpSolver__CONSTRUCTOR__0
  :: String -> String -> M.Map String Sparsity -> IO QpSolver
casadi__QpSolver__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QpSolver__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qpSolver__0 :: String -> String -> M.Map String Sparsity -> IO QpSolver
qpSolver__0 = casadi__QpSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__QpSolver__CONSTRUCTOR__1" c_casadi__QpSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr QpSolver')
casadi__QpSolver__CONSTRUCTOR__1
  :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO QpSolver
casadi__QpSolver__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QpSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qpSolver__1 :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO QpSolver
qpSolver__1 = casadi__QpSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__QpSolver__CONSTRUCTOR__2" c_casadi__QpSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr QpSolver')
casadi__QpSolver__CONSTRUCTOR__2
  :: IO QpSolver
casadi__QpSolver__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QpSolver__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qpSolver__2 :: IO QpSolver
qpSolver__2 = casadi__QpSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__QpSolver__doc" c_casadi__QpSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__QpSolver__doc
  :: String -> IO String
casadi__QpSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QpSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qpSolver_doc :: String -> IO String
qpSolver_doc = casadi__QpSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__QpSolver__generateNativeCode" c_casadi__QpSolver__generateNativeCode
  :: Ptr (Ptr StdString) -> Ptr QpSolver' -> Ptr StdString -> IO ()
casadi__QpSolver__generateNativeCode
  :: QpSolver -> String -> IO ()
casadi__QpSolver__generateNativeCode x0 x1 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QpSolver__generateNativeCode errStrPtrP x0' x1'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qpSolver_generateNativeCode :: QpSolverClass a => a -> String -> IO ()
qpSolver_generateNativeCode x = casadi__QpSolver__generateNativeCode (castQpSolver x)


-- direct wrapper
foreign import ccall unsafe "casadi__QpSolver__hasPlugin" c_casadi__QpSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__QpSolver__hasPlugin
  :: String -> IO Bool
casadi__QpSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QpSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qpSolver_hasPlugin :: String -> IO Bool
qpSolver_hasPlugin = casadi__QpSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__QpSolver__loadPlugin" c_casadi__QpSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__QpSolver__loadPlugin
  :: String -> IO ()
casadi__QpSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__QpSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
qpSolver_loadPlugin :: String -> IO ()
qpSolver_loadPlugin = casadi__QpSolver__loadPlugin

