{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.SdqpSolver
       (
         SdqpSolver,
         SdqpSolverClass(..),
         sdqpSolver__0,
         sdqpSolver__1,
         sdqpSolver__2,
         sdqpSolver_doc,
         sdqpSolver_hasPlugin,
         sdqpSolver_loadPlugin,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__SdqpSolver__CONSTRUCTOR__0" c_casadi__SdqpSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> IO (Ptr SdqpSolver')
casadi__SdqpSolver__CONSTRUCTOR__0
  :: String -> String -> M.Map String Sparsity -> IO SdqpSolver
casadi__SdqpSolver__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdqpSolver__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdqpSolver__0 :: String -> String -> M.Map String Sparsity -> IO SdqpSolver
sdqpSolver__0 = casadi__SdqpSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__SdqpSolver__CONSTRUCTOR__1" c_casadi__SdqpSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr SdqpSolver')
casadi__SdqpSolver__CONSTRUCTOR__1
  :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO SdqpSolver
casadi__SdqpSolver__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdqpSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdqpSolver__1 :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO SdqpSolver
sdqpSolver__1 = casadi__SdqpSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__SdqpSolver__CONSTRUCTOR__2" c_casadi__SdqpSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr SdqpSolver')
casadi__SdqpSolver__CONSTRUCTOR__2
  :: IO SdqpSolver
casadi__SdqpSolver__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdqpSolver__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdqpSolver__2 :: IO SdqpSolver
sdqpSolver__2 = casadi__SdqpSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__SdqpSolver__doc" c_casadi__SdqpSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__SdqpSolver__doc
  :: String -> IO String
casadi__SdqpSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdqpSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdqpSolver_doc :: String -> IO String
sdqpSolver_doc = casadi__SdqpSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__SdqpSolver__hasPlugin" c_casadi__SdqpSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__SdqpSolver__hasPlugin
  :: String -> IO Bool
casadi__SdqpSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdqpSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdqpSolver_hasPlugin :: String -> IO Bool
sdqpSolver_hasPlugin = casadi__SdqpSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__SdqpSolver__loadPlugin" c_casadi__SdqpSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__SdqpSolver__loadPlugin
  :: String -> IO ()
casadi__SdqpSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SdqpSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
sdqpSolver_loadPlugin :: String -> IO ()
sdqpSolver_loadPlugin = casadi__SdqpSolver__loadPlugin

