{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.SocpSolver
       (
         SocpSolver,
         SocpSolverClass(..),
         socpSolver__0,
         socpSolver__1,
         socpSolver__2,
         socpSolver_doc,
         socpSolver_hasPlugin,
         socpSolver_loadPlugin,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__SocpSolver__CONSTRUCTOR__0" c_casadi__SocpSolver__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> IO (Ptr SocpSolver')
casadi__SocpSolver__CONSTRUCTOR__0
  :: String -> String -> M.Map String Sparsity -> IO SocpSolver
casadi__SocpSolver__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SocpSolver__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
socpSolver__0 :: String -> String -> M.Map String Sparsity -> IO SocpSolver
socpSolver__0 = casadi__SocpSolver__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__SocpSolver__CONSTRUCTOR__1" c_casadi__SocpSolver__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr StdString -> Ptr (StdMap StdString (Ptr Sparsity')) -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr SocpSolver')
casadi__SocpSolver__CONSTRUCTOR__1
  :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO SocpSolver
casadi__SocpSolver__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SocpSolver__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
socpSolver__1 :: String -> String -> M.Map String Sparsity -> M.Map String GenericType -> IO SocpSolver
socpSolver__1 = casadi__SocpSolver__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__SocpSolver__CONSTRUCTOR__2" c_casadi__SocpSolver__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> IO (Ptr SocpSolver')
casadi__SocpSolver__CONSTRUCTOR__2
  :: IO SocpSolver
casadi__SocpSolver__CONSTRUCTOR__2  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SocpSolver__CONSTRUCTOR__2 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
socpSolver__2 :: IO SocpSolver
socpSolver__2 = casadi__SocpSolver__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__SocpSolver__doc" c_casadi__SocpSolver__doc
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO (Ptr StdString)
casadi__SocpSolver__doc
  :: String -> IO String
casadi__SocpSolver__doc x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SocpSolver__doc errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
socpSolver_doc :: String -> IO String
socpSolver_doc = casadi__SocpSolver__doc


-- direct wrapper
foreign import ccall unsafe "casadi__SocpSolver__hasPlugin" c_casadi__SocpSolver__hasPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO CInt
casadi__SocpSolver__hasPlugin
  :: String -> IO Bool
casadi__SocpSolver__hasPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SocpSolver__hasPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
socpSolver_hasPlugin :: String -> IO Bool
socpSolver_hasPlugin = casadi__SocpSolver__hasPlugin


-- direct wrapper
foreign import ccall unsafe "casadi__SocpSolver__loadPlugin" c_casadi__SocpSolver__loadPlugin
  :: Ptr (Ptr StdString) -> Ptr StdString -> IO ()
casadi__SocpSolver__loadPlugin
  :: String -> IO ()
casadi__SocpSolver__loadPlugin x0 =
  withMarshal x0 $ \x0' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__SocpSolver__loadPlugin errStrPtrP x0'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
socpSolver_loadPlugin :: String -> IO ()
socpSolver_loadPlugin = casadi__SocpSolver__loadPlugin

