{-# OPTIONS_GHC -Wall #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-orphans #-}
{-# Language ForeignFunctionInterface #-}
{-# Language FlexibleInstances #-}
{-# Language MultiParamTypeClasses #-}

module Casadi.Core.Classes.Switch
       (
         Switch,
         SwitchClass(..),
         switch__0,
         switch__1,
         switch__2,
         switch__3,
         switch__4,
       ) where


import Prelude hiding ( Functor )

import Data.Vector ( Vector )
import qualified Data.Map as M
import Foreign.C.Types
import Foreign.Marshal ( new, free )
import Foreign.Storable ( peek )
import Foreign.Ptr ( Ptr, nullPtr )
import Foreign.ForeignPtr ( newForeignPtr )
import System.IO.Unsafe ( unsafePerformIO ) -- for show instances

import Casadi.Internal.FormatException ( formatException )
import Casadi.Internal.MarshalTypes ( StdVec, StdString, StdMap, StdPair ) -- StdPair StdOstream'
import Casadi.Internal.Marshal ( Marshal(..), withMarshal )
import Casadi.Internal.WrapReturn ( WrapReturn(..) )
import Casadi.Core.Data
import Casadi.Core.Enums
-- direct wrapper
foreign import ccall unsafe "casadi__Switch__CONSTRUCTOR__0" c_casadi__Switch__CONSTRUCTOR__0
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr Function' -> Ptr Function' -> IO (Ptr Switch')
casadi__Switch__CONSTRUCTOR__0
  :: String -> Function -> Function -> IO Switch
casadi__Switch__CONSTRUCTOR__0 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__Switch__CONSTRUCTOR__0 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
switch__0 :: String -> Function -> Function -> IO Switch
switch__0 = casadi__Switch__CONSTRUCTOR__0


-- direct wrapper
foreign import ccall unsafe "casadi__Switch__CONSTRUCTOR__1" c_casadi__Switch__CONSTRUCTOR__1
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr Function' -> Ptr Function' -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr Switch')
casadi__Switch__CONSTRUCTOR__1
  :: String -> Function -> Function -> M.Map String GenericType -> IO Switch
casadi__Switch__CONSTRUCTOR__1 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__Switch__CONSTRUCTOR__1 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
switch__1 :: String -> Function -> Function -> M.Map String GenericType -> IO Switch
switch__1 = casadi__Switch__CONSTRUCTOR__1


-- direct wrapper
foreign import ccall unsafe "casadi__Switch__CONSTRUCTOR__2" c_casadi__Switch__CONSTRUCTOR__2
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr (StdVec (Ptr Function')) -> Ptr Function' -> IO (Ptr Switch')
casadi__Switch__CONSTRUCTOR__2
  :: String -> Vector Function -> Function -> IO Switch
casadi__Switch__CONSTRUCTOR__2 x0 x1 x2 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__Switch__CONSTRUCTOR__2 errStrPtrP x0' x1' x2'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
switch__2 :: String -> Vector Function -> Function -> IO Switch
switch__2 = casadi__Switch__CONSTRUCTOR__2


-- direct wrapper
foreign import ccall unsafe "casadi__Switch__CONSTRUCTOR__3" c_casadi__Switch__CONSTRUCTOR__3
  :: Ptr (Ptr StdString) -> Ptr StdString -> Ptr (StdVec (Ptr Function')) -> Ptr Function' -> Ptr (StdMap StdString (Ptr GenericType')) -> IO (Ptr Switch')
casadi__Switch__CONSTRUCTOR__3
  :: String -> Vector Function -> Function -> M.Map String GenericType -> IO Switch
casadi__Switch__CONSTRUCTOR__3 x0 x1 x2 x3 =
  withMarshal x0 $ \x0' ->
  withMarshal x1 $ \x1' ->
  withMarshal x2 $ \x2' ->
  withMarshal x3 $ \x3' ->
  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__Switch__CONSTRUCTOR__3 errStrPtrP x0' x1' x2' x3'
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
switch__3 :: String -> Vector Function -> Function -> M.Map String GenericType -> IO Switch
switch__3 = casadi__Switch__CONSTRUCTOR__3


-- direct wrapper
foreign import ccall unsafe "casadi__Switch__CONSTRUCTOR__4" c_casadi__Switch__CONSTRUCTOR__4
  :: Ptr (Ptr StdString) -> IO (Ptr Switch')
casadi__Switch__CONSTRUCTOR__4
  :: IO Switch
casadi__Switch__CONSTRUCTOR__4  =

  do
    errStrPtrP <- new nullPtr
    ret <- c_casadi__Switch__CONSTRUCTOR__4 errStrPtrP 
    errStrPtr <- peek errStrPtrP
    free errStrPtrP
    if errStrPtr == nullPtr then wrapReturn ret else wrapReturn errStrPtr >>= (error . formatException)


-- classy wrapper
switch__4 :: IO Switch
switch__4 = casadi__Switch__CONSTRUCTOR__4

